// Programming 2D Games
// Copyright (c) 2011 by: 
// Charles Kelly
// createThisClass.h

#ifndef _PONG_H           // Prevent multiple definitions if this 
#define _PONG_H           // file is included in more than one place
#define WIN32_LEAN_AND_MEAN

#include <string>
#include <sstream>
#include "game.h"
#include "textureManager.h"
#include "image.h"
#include "textDX.h"
#include "paddle.h"
#include "ball.h"
#include "entity.h"

//=============================================================================
// This class is the core of the game
//=============================================================================
class Pong : public Game
{
private:
    // game items
    TextureManager backgroundTexture; // textures
	TextureManager paddle1Texture; // paddle textures
	TextureManager paddle2Texture; // paddle textures
	TextureManager ballTexture; // paddle textures
	Paddle	paddle1;				// paddle1
	Paddle	paddle2;				// paddle2
	Ball    ball;					// ball
	int	winner;					//who touched the ball last
    Image   background;        // background image
    TextDX  *dxFont;            // DirectX font
    int  score1;		// player 1 score
	int  score2;		//player 2 score
 

public:
    // Constructor
    Pong();
    // Destructor
    virtual ~Pong();
    // Initialize the game
    void initialize(HWND hwnd);
    void update();      // must override pure virtual from Game
    void ai();          // "
    void collisions();  // "
    void render();      // "
    void releaseAll();
    void resetAll();
};

#endif
